function Callbacks.SetShieldSize(data)
	for id, size in data.EntityTable do
		local unit = GetEntityById(id)
		if unit.MyShield:IsOn() then
			local bp = unit:GetBlueprint()
			if unit.ShieldResizeThread then
				KillThread(unit.ShieldResizeThread)
				unit.ShieldResizeThread = nil
			end
			UpdateSize(unit.MyShield,bp,size)
		end
	end
end



UpdateSize = function(Shield,bp,Size)
	if not Shield.Owner.ShieldResizeThread then
		Shield.Owner.ShieldResizeThread = Shield.Owner:ForkThread(function(self,Shield,bp,Size)
					--local energyratio =  Shield.Owner.originalsize * (Size /bp.Defense.Shield.ShieldSize)
# 									Shield:TurnOff()
# 									Shield:SetSize(Size)
# 									local newOffset = CalculateOffset(Shield,bp,Size)
# 									Shield:SetVerticalOffset(newOffset)
# 									WaitTicks(1)
# 									Shield:TurnOn()
# 									Shield.Owner:SetEnergyMaintenanceConsumptionOverride(energyratio)
					local newsize = math.abs(Size - Shield.Size)
					if Shield.Size >= Size then
						Shield.Increase = true
					else
						Shield.Increase = false
					end
					Shield.CurrentSize = Shield.Size
					while true do
						for i=0, newsize  do
							if Shield:IsOn() and Shield.Owner:GetAIBrain():GetEconomyStored('ENERGY') > 0 then
							--	LOG('Thread running')
								if Shield.Increase then
									Shield.size = Shield.CurrentSize - i
								else
									Shield.size = Shield.CurrentSize + i
								end
								local newOffset = CalculateOffset(Shield,bp,Shield.size)
								
								Shield:SetCollisionShape('Sphere', 0, 0, 0, i / 2) 
								Shield:SetParentOffset(Vector(0,newOffset,0)) 
								Shield:SetDrawScale(Shield.size) 
								Shield.Size = Shield.size
								Shield.ShieldVerticalOffset = newOffset
								Shield.MeshZ:SetDrawScale(Shield.size) 
		
								Shield.MeshZ:SetParentOffset(Vector(0,newOffset,0)) 
						   		local energyratio =  bp.Economy.MaintenanceConsumptionPerSecondEnergy * (Shield.size /bp.Defense.Shield.ShieldSize)
								--bp.Economy.MaintenanceConsumptionPerSecondEnergy = energyratio
								Shield.Owner:SetEnergyMaintenanceConsumptionOverride(energyratio)
								Shield.Owner:SetConsumptionPerSecondEnergy(energyratio)
					   		
								WaitTicks(1)
								if i == math.floor(newsize) then break end
							else
								ChangeState(Shield, Shield.EnergyDrainRechargeState)
							end
						end
						Shield.Owner.ShieldResizeThread = nil
				   		break
					end
				   end,
				   		Shield,bp,Size)

	end
end

CalculateOffset = function(Shield,bp,size)
	local minsize, maxsize = CalculateSizes(Shield)
	local minoffset,maxoffset = 0, bp.Defense.Shield.ShieldVerticalOffset *1.5 - 0.617263328
	local currentoffset = (( (maxoffset-minoffset)/(maxsize-minsize)  ) * (size - minsize))
	return currentoffset
end

CalculateSizes = function(Shield)
 	local bp = Shield.Owner:GetBlueprint()
	local x,y,z = bp.SizeX*2,bp.SizeY*2,bp.SizeZ*2
	local minsize = math.sqrt(math.pow(x, 2) + math.pow(y, 2) + math.pow(z, 2))
	local maxsize =  bp.Defense.Shield.ShieldSize * 1.5
	local normalsize = bp.Defense.Shield.ShieldSize
 	--LOG('Minsize ; ', minsize)
-- 	LOG('Maxsize ; ', maxsize)
	return minsize, maxsize
end

